﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace GraphicalObjectFile
{
    public enum EntityType { LINE, RECTANGLE, ELLIPSE}
    public class GraphicalObject
    {
        public UInt16 X {  get; set; }
        public UInt16 Y { get; set; }
        public UInt16 DX { get; set; }
        public UInt16 DY { get; set; }
        public EntityType Type { get; set; }
        public override string ToString()
        {
            return string.Format("{0};{1};{2};{3};{4}",X,Y,DX,DY,Type);
        }

        public static GraphicalObject parse(string text)
        {
            GraphicalObject obj = new GraphicalObject();
            string[] parts = text.Split(';',5);
            if(parts.Length < 5)
            {
                throw new FormatException("Invalid CSV format. Line should contain 5 parts.");
            }
            try
            {
                obj.X = UInt16.Parse(parts[0]);
                obj.Y = UInt16.Parse(parts[1]);
                obj.DX = UInt16.Parse(parts[2]);
                obj.DY = UInt16.Parse(parts[3]);
                obj.Type = (EntityType)Enum.Parse(typeof(EntityType), parts[4]);
            }catch(FormatException ex) 
            { 
                MessageBox.Show(ex.Message);
                obj=null;
            }
            return obj;

        }

    }
}
